import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.jfree.chart.*;
import org.jfree.chart.axis.CategoryAxis3D;
import org.jfree.chart.axis.CategoryLabelPositions;
import org.jfree.chart.axis.NumberAxis3D;
import org.jfree.chart.axis.NumberTickUnit;
import org.jfree.chart.labels.StandardCategoryItemLabelGenerator;
import org.jfree.chart.labels.StandardCategoryToolTipGenerator;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.DatasetRenderingOrder;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.BarRenderer3D;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.data.category.DefaultCategoryDataset;


public class UpdateServer extends Thread
{
	private SeverList serverlist_list = null;
	private SeverList serverlist = null;
	private File file =null;
	
	public UpdateServer()
	{
		this.serverlist = main_program.serverlist_head;	
		this.serverlist_list = this.serverlist;
	}
	
	public void run() 
	{
		//ָڴ
		try {
			//ѭǰĳʼ
			file = new File("e:\\a.png");
			//ͼ
	        DefaultCategoryDataset lineDataset = new DefaultCategoryDataset();
	      //״ͼ
	         DefaultCategoryDataset dataset = new DefaultCategoryDataset();
	         //ɵ״ͼ
	        JFreeChart chart = ChartFactory.createBarChart3D(
	                   "",
	                   "ڵ",//Xıǩ 
	                   "ڴʹ",//Yıǩ 
	                   dataset, //ͼʾݼ
	                   PlotOrientation.VERTICAL, //ͼʾʽˮƽߴֱ
	                   false,//Ƿʾӱ 
	                   false,//Ƿʾıǩ 
	                   false); //ǷURL

	            /*
	             * ͼϵ
	             */

	            //
	            chart.getTitle().setFont(new Font("",Font.BOLD,18));

	            //ȡͼ
	            CategoryPlot categoryPlot = (CategoryPlot)chart.getPlot();

	            //ȡXĶ
	            CategoryAxis3D categoryAxis3D = (CategoryAxis3D)categoryPlot.getDomainAxis();

	            //ȡYĶ
	            NumberAxis3D numberAxis3D = (NumberAxis3D)categoryPlot.getRangeAxis();

	            //Xϵ
	            categoryAxis3D.setTickLabelFont(new Font("",Font.BOLD,10));

	            //X
	            categoryAxis3D.setLabelFont(new Font("",Font.BOLD,10));

	            //Yϵ
	            numberAxis3D.setTickLabelFont(new Font("",Font.BOLD,10));

	            //Y
	            numberAxis3D.setLabelFont(new Font("",Font.BOLD,10));

	            //ԶYʾĿ̶ȣ10Ϊ1
	            numberAxis3D.setAutoTickUnitSelection(false);
	            NumberTickUnit unit = new NumberTickUnit(10); 
	            numberAxis3D.setTickUnit(unit);

	            //ȡͼ
	            BarRenderer3D barRenderer3D = (BarRenderer3D)categoryPlot.getRenderer();

	            //ͼĿ
	            barRenderer3D.setMaximumBarWidth(0.07);

	            //ͼʾ
	            barRenderer3D.setBaseItemLabelGenerator(new StandardCategoryItemLabelGenerator());
	            barRenderer3D.setBaseItemLabelsVisible(true);
	            barRenderer3D.setBaseItemLabelFont(new Font("",Font.BOLD,10));

	            /*
	             * ͼ
	             */
	            categoryPlot.setDataset(1, lineDataset);
	            //
	            LineAndShapeRenderer lineandshaperenderer = new LineAndShapeRenderer();
	            lineandshaperenderer.setToolTipGenerator(new StandardCategoryToolTipGenerator());
	            categoryPlot.setRenderer(1, lineandshaperenderer);
	            // ״ͼ
	            categoryAxis3D.setLowerMargin(0.0); 

	            categoryAxis3D.setCategoryLabelPositions(CategoryLabelPositions.DOWN_45);
	            //ǰʾ
	            categoryPlot.setDatasetRenderingOrder(DatasetRenderingOrder.FORWARD);

	            //GUI
	            JFrame newFrame=new JFrame("funBox");       
	            newFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);   //JFrameرʱĲ裩Чⲻܹرպ̨ǰ̵    
	            newFrame.setSize(1050, 850);      //JFrame
	            newFrame.setLocation(200, 200);
	            newFrame.setVisible(true); 
	            
	            //ʼͼƬ
	            BufferedImage image = null;
	          
			while(! AllocateTask.task_finish)
			{
				 lineDataset.clear();
				 dataset.clear();
		         while(serverlist_list.getNext() != null)
		         {
		        	 serverlist_list = serverlist_list.getNext();
		        	 //һ,ڶͼƬʾ,Ǻ,ǿͼ
		            lineDataset.addValue(100, "", serverlist_list.get_host_name()+":"+serverlist_list.exec_task);
		            //ݣ״ͼ
		            dataset.addValue(serverlist_list.print_rate(), "", serverlist_list.get_host_name()+":"+serverlist_list.exec_task);
		            //ʵʱӡ
		           // System.out.println(serverlist_list.get_host_name()+":"+serverlist_list.print_rate()+"%");
		         }
		         
		         //ͼƬ  
		          image = chart.createBufferedImage(1000, 800,BufferedImage.TYPE_INT_RGB, null);  
		         
		            
		           //ͼƬ
		            ImagePanel mypanel = new ImagePanel();
		            mypanel.setImage(image);
		            Container con = newFrame.getContentPane(); 
		            con.add(mypanel, BorderLayout.CENTER); 
		            //һҪ¸Ҫʾ
		            newFrame.setVisible(true); 
		            
				//ָserver_listΪͷڵ
		          this.serverlist_list = this.serverlist;
		         
				  Thread.sleep(10);
				  image.flush();
				  newFrame.getContentPane().remove(mypanel);
			}
			
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	

}
